{% extends 'site_base.html' %}
{% load static %}
{% load crispy_forms_tags %}

{% block content %}


<div class="box box-primary">
    <head>
        <title>{% block title %}{% if product %} Edit Product {% else %} Create Product {% endif%} {% endblock %}</title>
    </head>
    <div class="box-header with-border">
        <span id="btn-back" class="glyphicon glyphicon-circle-arrow-left"></span>
        {% if product %}
        <h3 class="box-title"><p>Edit Product</p></h3>
        {% else %}
        <h3 class="box-title"><p>Create Product</p></h3>
        {% endif %}
    </div>
    <form id="formSubmit" method="POST" novalidate>
        {% csrf_token %}
        <div class="box-body">
            <h4 style="color: red; text-align: center"><strong>{{message}}</strong></h4>

            <div class="form-group col-md-12 col-sm-12">
                <div id="div_id_product_category"
                     class="form-group {% if product_create_form.product_category.errors %} has-error {% endif %}">
                    <label for="id_product_category" class="control-label requiredField">
                        Product Category <span class="asteriskField">*</span>
                    </label>
                    <div class="controls">
                        <div id="product_category_app">
                            <treeselect id="id_product_category" name="product_category" :multiple="false"
                                        :options="options"
                                        placeholder="Select Product Category..." v-model="selected_category"
                                        :load-options="loadOptions"/>
                        </div>
                        {% for x in product_create_form.product_category.errors %}
                        <p class="help-block"><strong>{{x}}</strong></p>
                        {% endfor %}
                    </div>
                </div>
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.sku_code|as_crispy_field}}
                <input type="hidden" name="brand" id="txtbrand">
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.max_retail_price|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.dealer_price|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.best_buying_price|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12">
                <!-- {{product_create_form.product_category_code|as_crispy_field}} -->
                <label for="id_dealer_price" class="control-label  requiredField">
                    Product category code<span class="asteriskField">*</span>
                </label>
                <select name="product_category_code" id="id_product_category_code" class="select form-control" required>
                    <option>-----</option>
                    {% for product_category in queryset %}
                    <option {% if instance1.scheme_category_code in product_category.pk %}selected{% endif %} value="{{product_category.pk}}">{{product_category.scheme_category_name}}</option>
                    {% endfor %}
                        
                    
                </select>
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.size_capacity|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.size_capacity_unit|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.pattern_color|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.product_description_feature|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12">
                {{product_create_form.TaxSlabCode|as_crispy_field}}
            </div>

            <div class="form-group col-md-12 col-sm-12 text-right">
                <input type="submit" value="Submit" class="btn btn-primary"/>
            </div>
        </div>
    </form>
</div>

{% endblock %}

{% block extra_style_block %}
{{ block.super }}
<script src="{% static 'plugins/vue/vue.min.js' %}"></script>
<script src="{% static 'plugins/vue/treeview/vue-treeselect.min.js' %}"></script>
<link href="{% static 'plugins/vue/treeview/vue-treeselect.min.css' %}" rel="stylesheet"/>

{% endblock %}

{% block extra_script_block %}
    {{block.super}}

    <script>
        var category_list = [];
        $(document).ready(function(){
            $('#txtbrand').val($("#top_brand").val());
            $("#top_brand").change(function(){
                $('#txtbrand').val($("#top_brand").val());
            });

            //<!--alert($("#top_brand option:selected").val())-->
           // <!--alert($("#top_brand option:selected").text());-->

            //<!--=======================-->
            $("#formSubmit").submit(function(event) {
                debugger;
                var product = $("input[name='product_category']").val();
                product = product.replace('[','').replace(']','')
                $("input[name='product_category']").val(product);
                return true;
            });
            //<!--=======================-->

            var disabled = '{{disabled}}';
            if(disabled=='True'){
                $("#id_sku_code").attr("readonly", "readonly");
            }

            $.ajax({
                type:'get',
                url:'/master/get/product_category',
                success: function(res){
                    category_list = JSON.parse(res);
                    initTreeView();
                }
            });
        });

        function initTreeView(){
            Vue.component('treeselect', VueTreeselect.Treeselect);
            const sleep = d => new Promise(r => setTimeout(r, d));
            let called = false;

            let tree = new Vue({
                el: '#product_category_app',
                data: {
                    selected_category: {% if product_create_form.product_category.value %} [{{product_create_form.product_category.value}}] {% else %} null {% endif %},
                    //options: category_list
                    options: null
                },
                watch:{
                    'selected_category': function(newVal, oldVal){
                        console.log(newVal);
                        $("#id_product_category").val(newVal).attr(value);
                    }
                },
                methods: {
                     async loadOptions({ action/*, callback*/ }) {
                      if (action === 'LOAD_ROOT_OPTIONS') {

                        if (!called) {
                          // First try: simulate an exception.

                          await sleep(1000) // Simulate an async operation.
                          called = true
                          $.ajax({
                            type:'get',
                            url:'/master/get/product_category',
                            success: function(res){
                                tree.options = JSON.parse(res);
                            }, error: function(err){
                                throw new Error('Failed to load options: test.')
                            }
                          });
                        }
                        else {
                            $.ajax({
                                type:'get',
                                url:'/master/get/product_category',
                                success: function(res){
                                    tree.options = JSON.parse(res);
                                }, error: function(err){
                                    throw new Error('Failed to load options: test.')
                                }
                            });
                        }
                      }
                     },
                }
            });
        }
    </script>
{% endblock %}